Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class HashMap

    java.lang.Object
      |
      +--java.util.AbstractMap
            |
            +--java.util.HashMap

All Implemented Interfaces:
  Cloneable, Map, Serializable

public class HashMap
extends AbstractMap
implements Map, Cloneable, Serializable

Hash table based implementation of the `Map` interface. This implementation provides all of the optional map operations, and permits `null` values and the `null` key. (The `HashMap` class is roughly equivalent to `Hashtable`, except that it is unsynchronized and permits nulls.) This class makes no guarantees as to the order of the map; in particular, it does not guarantee that the order will remain constant over time.

This implementation provides constant-time performance for the basic operations (`get` and `put`), assuming the hash function disperses the elements properly among the buckets. Iteration over collection views requires time proportional to the "capacity" of the `HashMap` instance (the number of buckets) plus its size (the number of key-value mappings). Thus, it's very important not to set the intial capacity too high (or the load factor too low) if iteration performance is important.

An instance of `HashMap` has two parameters that affect its performance: initial capacity and load factor. The capacity is the number of buckets in the hash table, and the initial capacity is simply the capacity at the time the hash table is created. The load factor is a measure of how full the hash table is allowed to get before its capacity is automatically increased. When the number of entries in the hash table exceeds the product of the load factor and the current capacity, the capacity is roughly doubled by calling the `rehash` method.

As a general rule, the default load factor (.75) offers a good tradeoff between time and space costs. Higher values decrease the space overhead but increase the lookup cost (reflected in most of the operations of the `HashMap` class, including `get` and `put`). The expected number of entries in the map and its load factor should be taken into account when setting its initial capacity, so as to minimize the number of `rehash` operations. If the initial capacity is greater than the maximum number of entries divided by the load factor, no `rehash` operations will ever occur.

If many mappings are to be stored in a `HashMap` instance, creating it with a sufficiently large capacity will allow the mappings to be stored more efficiently than letting it perform automatic rehashing as needed to grow the table.

Note that this implementation is not synchronized. If multiple threads access this map concurrently, and at least one of the threads modifies the map structurally, it must be synchronized externally. (A structural modification is any operation that adds or deletes one or more mappings; merely changing the value associated with a key that an instance already contains is not a structural modification.) This is typically accomplished by synchronizing on some object that naturally encapsulates the map. If no such object exists, the map should be "wrapped" using the `Collections.synchronizedMap` method. This is best done at creation time, to prevent accidental unsynchronized access to the map:

     Map m = Collections.synchronizedMap(new HashMap(...));

The iterators returned by all of this class's "collection view methods" are fail-fast: if the map is structurally modified at any time after the iterator is created, in any way except through the iterator's own `remove` or `add` methods, the iterator will throw a `ConcurrentModificationException`. Thus, in the face of concurrent modification, the iterator fails quickly and cleanly, rather than risking arbitrary, non-deterministic behavior at an undetermined time in the future.

Since:
  1.2
See Also:
  `Object.hashCode()`, `Collection`, `Map`, `TreeMap`, `Hashtable`, Serialized Form

Inner classes inherited from class java.util.Map
`Map.Entry`

Constructor Summary
`HashMap()` Constructs a new, empty map with a default capacity and load factor, which is `0.75`.
`HashMap(int initialCapacity)` Constructs a new, empty map with the specified initial capacity and default load factor, which is `0.75`.
`HashMap(int initialCapacity, float loadFactor)` Constructs a new, empty map with the specified initial capacity and the specified load factor.
`HashMap(Map t)` Constructs a new map with the same mappings as the given map.

Method Summary
`void` | `clear()` Removes all mappings from this map.
`Object` | `clone()` Returns a shallow copy of this `HashMap` instance: the keys and values themselves are not cloned.
`boolean` | `containsKey(Object key)` Returns `true` if this map contains a mapping for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if this map maps one or more keys to the specified value.
`Set` | `entrySet()` Returns a collection view of the mappings contained in this map.
`Object` | `get(Object key)` Returns the value to which this map maps the specified key.
`boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
`Set` | `keySet()` Returns a set view of the keys contained in this map.
`Object` | `put(Object key, Object value)` Associates the specified value with the specified key in this map.
`void` | `putAll(Map t)` Copies all of the mappings from the specified map to this one.
`Object` | `remove(Object key)` Removes the mapping for this key from this map if present.
`int` | `size()` Returns the number of key-value mappings in this map.
`Collection` | `values()` Returns a collection view of the values contained in this map.

Methods inherited from class java.util.AbstractMap
`equals, hashCode, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`equals, hashCode`

Constructor Detail

### HashMap

    public HashMap(int initialCapacity,
                   float loadFactor)

  Constructs a new, empty map with the specified initial capacity and the specified load factor.
  Parameters:
    `initialCapacity` - the initial capacity of the HashMap.
    `loadFactor` - the load factor of the HashMap
  Throws:
    `IllegalArgumentException` - if the initial capacity is less than zero, or if the load factor is nonpositive.

### HashMap

    public HashMap(int initialCapacity)

  Constructs a new, empty map with the specified initial capacity and default load factor, which is `0.75`.
  Parameters:
    `initialCapacity` - the initial capacity of the HashMap.
  Throws:
    `IllegalArgumentException` - if the initial capacity is less than zero.

### HashMap

    public HashMap()

  Constructs a new, empty map with a default capacity and load factor, which is `0.75`.

### HashMap

    public HashMap(Map t)

  Constructs a new map with the same mappings as the given map. The map is created with a capacity of twice the number of mappings in the given map or 11 (whichever is greater), and a default load factor, which is `0.75`.
  Parameters:
    `t` - the map whose mappings are to be placed in this map.

Method Detail

### size

    public int size()

  Returns the number of key-value mappings in this map.
  Specified by:
    `size` in interface `Map`
  Overrides:
    `size` in class `AbstractMap`
  Returns:
    the number of key-value mappings in this map.

### isEmpty

    public boolean isEmpty()

  Returns `true` if this map contains no key-value mappings.
  Specified by:
    `isEmpty` in interface `Map`
  Overrides:
    `isEmpty` in class `AbstractMap`
  Returns:
    `true` if this map contains no key-value mappings.

### containsValue

    public boolean containsValue(Object value)

  Returns `true` if this map maps one or more keys to the specified value.
  Specified by:
    `containsValue` in interface `Map`
  Overrides:
    `containsValue` in class `AbstractMap`
  Parameters:
    `value` - value whose presence in this map is to be tested.
  Returns:
    `true` if this map maps one or more keys to the specified value.

### containsKey

    public boolean containsKey(Object key)

  Returns `true` if this map contains a mapping for the specified key.
  Specified by:
    `containsKey` in interface `Map`
  Overrides:
    `containsKey` in class `AbstractMap`
  Parameters:
    `key` - key whose presence in this Map is to be tested.
  Returns:
    `true` if this map contains a mapping for the specified key.

### get

    public Object get(Object key)

  Returns the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key. A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.
  Specified by:
    `get` in interface `Map`
  Overrides:
    `get` in class `AbstractMap`
  Parameters:
    `key` - key whose associated value is to be returned.
  Returns:
    the value to which this map maps the specified key.

### put

    public Object put(Object key,
                      Object value)

  Associates the specified value with the specified key in this map. If the map previously contained a mapping for this key, the old value is replaced.
  Specified by:
    `put` in interface `Map`
  Overrides:
    `put` in class `AbstractMap`
  Parameters:
    `key` - key with which the specified value is to be associated.
    `value` - value to be associated with the specified key.
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the HashMap previously associated `null` with the specified key.

### remove

    public Object remove(Object key)

  Removes the mapping for this key from this map if present.
  Specified by:
    `remove` in interface `Map`
  Overrides:
    `remove` in class `AbstractMap`
  Parameters:
    `key` - key whose mapping is to be removed from the map.
  Returns:
    previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the map previously associated `null` with the specified key.

### putAll

    public void putAll(Map t)

  Copies all of the mappings from the specified map to this one. These mappings replace any mappings that this map had for any of the keys currently in the specified Map.
  Specified by:
    `putAll` in interface `Map`
  Overrides:
    `putAll` in class `AbstractMap`
  Parameters:
    `t` - Mappings to be stored in this map.

### clear

    public void clear()

  Removes all mappings from this map.
  Specified by:
    `clear` in interface `Map`
  Overrides:
    `clear` in class `AbstractMap`
  Following copied from interface: `java.util.Map`
  Throws:
    `UnsupportedOperationException` - clear is not supported by this map.

### clone

    public Object clone()

  Returns a shallow copy of this `HashMap` instance: the keys and values themselves are not cloned.
  Overrides:
    `clone` in class `Object`
  Returns:
    a shallow copy of this map.

### keySet

    public Set keySet()

  Returns a set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
  Specified by:
    `keySet` in interface `Map`
  Overrides:
    `keySet` in class `AbstractMap`
  Returns:
    a set view of the keys contained in this map.

### values

    public Collection values()

  Returns a collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
  Specified by:
    `values` in interface `Map`
  Overrides:
    `values` in class `AbstractMap`
  Returns:
    a collection view of the values contained in this map.

### entrySet

    public Set entrySet()

  Returns a collection view of the mappings contained in this map. Each element in the returned collection is a `Map.Entry`. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
  Specified by:
    `entrySet` in interface `Map`
  Overrides:
    `entrySet` in class `AbstractMap`
  Returns:
    a collection view of the mappings contained in this map.
  See Also:
    `Map.Entry`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.